%%%%%%%%%%%%%%	Attributes Types	%%%%%%%%%%%%%%%%

xtype[name:tpe_bpmn_entit,base:symbolic,length:4,scale:0,desc:'bpmn entity 1 - executed, null - not executed',domain:[null,1]].
xtype[name:integer,base:numeric,length:10,scale:0,desc:integer,domain:[-2147483648 to 2147483647]].
xtype[name:tpe_operation,base:symbolic,length:10,scale:0,desc:operation_type,domain:[status,withdrawal]].

%%%%%%%%%%%%%%	Attributes	%%%%%%%%%%%%%%%%

xattr[name:start,abbrev:start1,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f1,abbrev:f11,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:cardID,abbrev:cardID1,class:simple,type:integer,comm:inter,callback:[get_cardID,[cardID]]].
xattr[name:'Pin Request',abbrev:'Pin Request1',class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f2,abbrev:f21,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f3,abbrev:f31,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f4,abbrev:f41,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:correctPin,abbrev:correctPin1,class:simple,type:integer,comm:inter,callback:[get_correctPin,[correctPin]]].
xattr[name:enteredPin,abbrev:enteredPin1,class:simple,type:integer,comm:inter,callback:[get_enteredPin,[enteredPin]]].
xattr[name:'Operation Type Select',abbrev:'Operation Type Select1',class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f5,abbrev:f51,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f6,abbrev:f61,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f7,abbrev:f71,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f8,abbrev:f81,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:operation,abbrev:operation1,class:simple,type:tpe_operation,comm:inter,callback:[get_operation,[operation]]].
xattr[name:f9,abbrev:f91,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f10,abbrev:f101,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:'Account Status Check (1)',abbrev:'Account Status Check (1)1',class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f11,abbrev:f111,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:accountAmount,abbrev:accountAmount1,class:simple,type:integer,comm:inter,callback:[get_accountAmount,[accountAmount]]].
xattr[name:'Wait Screen Display',abbrev:'Wait Screen Display1',class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f12,abbrev:f121,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f13,abbrev:f131,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:'Acount Status Presentation',abbrev:'Acount Status Presentation1',class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f14,abbrev:f141,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:'Desired Amount Ask',abbrev:'Desired Amount Ask1',class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f15,abbrev:f151,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f16,abbrev:f161,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:desiredAmount,abbrev:desiredAmount1,class:simple,type:integer,comm:inter,callback:[get_desiredAmount,[desiredAmount]]].
xattr[name:f17,abbrev:f171,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:'Account Status Check (2)',abbrev:'Account Status Check (2)1',class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f18,abbrev:f181,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f19,abbrev:f191,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f20,abbrev:f201,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f21,abbrev:f211,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:'Payout',abbrev:'Payout1',class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f22,abbrev:f221,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:'Not Enough On Account',abbrev:'Not Enough On Account1',class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f23,abbrev:f231,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f24,abbrev:f241,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:end,abbrev:end1,class:simple,type:tpe_bpmn_entit,comm:inter].


%%%%%%%%%%%%%%	XTT Tables	%%%%%%%%%%%%%%%%

xschm xtt_start: [] ==> [f1,start].
xschm 'xtt_Pin Request': [f1,cardID] ==> [f2,'Pin Request'].
xschm xtt_gateway1: [f2,correctPin] ==> [f3,f4].
xschm 'xtt_Operation Type Select': [f4,correctPin] ==> [f5,'Operation Type Select'].
xschm xtt_gateway2: [f5,operation] ==> [f6,f7,f8].
xschm xtt_gateway3: [f6] ==> [f9,f10].
xschm 'xtt_Account Status Check (1)': [f9] ==> [f11,'Account Status Check (1)'].
xschm 'xtt_Wait Screen Display': [f10] ==> [f12,'Wait Screen Display'].
xschm xtt_gateway4: [f12,f11] ==> [f13].
xschm 'xtt_Acount Status Presentation': [f13] ==> [f14,'Acount Status Presentation'].
xschm 'xtt_Desired Amount Ask': [f15] ==> [f16,'Desired Amount Ask'].
xschm xtt_gateway5: [f7] ==> [f17,f15].
xschm 'xtt_Account Status Check (2)': [f17] ==> [f18,'Account Status Check (2)'].
xschm xtt_gateway6: [f18,f16] ==> [f19].
xschm xtt_gateway7: [f19,desiredAmount] ==> [f20,f21].
xschm xtt_Payout: [f20,desiredAmount] ==> [f22,'Payout'].
xschm 'xtt_Not Enough On Account': [f21] ==> [f23,'Not Enough On Account'].
xschm xtt_gateway8: [f23,f22] ==> [f24].
xschm xtt_end: [f14,f24,f8,f3] ==> [end].


xrule xtt_start/1: [] ==> [f1 set 1] **> [[on_start,[start]]].
xrule 'xtt_Pin Request'/1: [f1 eq 1,cardID eq any] ==> ['Pin Request' set 1,f2 set 1] **> [['on_Pin Request',['Pin Request']]].
xrule xtt_gateway1/1: [f2 eq 1,correctPin eq ${enteredPin}] ==> [f4 set 1].
xrule xtt_gateway1/2: [f2 eq 1,f4 eq null] ==> [f3 set 1].
xrule 'xtt_Operation Type Select'/1: [f4 eq 1,correctPin eq ${enteredPin}] ==> ['Operation Type Select' set 1,f5 set 1] **> [['on_Operation Type Select',['Operation Type Select']]].
xrule xtt_gateway2/1: [f5 eq 1,operation eq status] ==> [f6 set 1].
xrule xtt_gateway2/2: [f5 eq 1,f6 eq null,operation eq withdrawal] ==> [f7 set 1].
xrule xtt_gateway2/3: [f5 eq 1,f6 eq null,f7 eq null] ==> [f8 set 1].
xrule xtt_gateway3/1: [f6 eq 1] ==> [f9 set 1,f10 set 1].
xrule 'xtt_Account Status Check (1)'/1: [f9 eq 1] ==> ['Account Status Check (1)' set 1,f11 set 1] **> [['on_Account Status Check (1)',['Account Status Check (1)']]].
xrule 'xtt_Wait Screen Display'/1: [f10 eq 1] ==> ['Wait Screen Display' set 1,f12 set 1] **> [['on_Wait Screen Display',['Wait Screen Display']]].
xrule xtt_gateway4/1: [f12 eq 1,f11 eq 1,accountAmount eq any] ==> [f13 set 1].
xrule 'xtt_Acount Status Presentation'/1: [f13 eq 1] ==> ['Acount Status Presentation' set 1,f14 set 1] **> [['on_Acount Status Presentation',['Acount Status Presentation']]].
xrule 'xtt_Desired Amount Ask'/1: [f15 eq 1] ==> ['Desired Amount Ask' set 1,f16 set 1] **> [['on_Desired Amount Ask',['Desired Amount Ask']]].
xrule xtt_gateway5/1: [f7 eq 1] ==> [f17 set 1,f15 set 1].
xrule 'xtt_Account Status Check (2)'/1: [f17 eq 1] ==> ['Account Status Check (2)' set 1,f18 set 1] **> [['on_Account Status Check (2)',['Account Status Check (2)']]].
xrule xtt_gateway6/1: [f18 eq 1,accountAmount eq any,f16 eq 1,desiredAmount eq any] ==> [f19 set 1].
xrule xtt_gateway7/1: [f19 eq 1,desiredAmount lte ${accountAmount}] ==> [f20 set 1].
xrule xtt_gateway7/2: [f19 eq 1,f20 eq null] ==> [f21 set 1].
xrule xtt_Payout/1: [f20 eq 1,desiredAmount lte ${accountAmount}] ==> ['Payout' set 1,f22 set 1] **> [[on_Payout,['Payout']]].
xrule 'xtt_Not Enough On Account'/1: [f21 eq 1] ==> ['Not Enough On Account' set 1,f23 set 1] **> [['on_Not Enough On Account',['Not Enough On Account']]].
xrule xtt_gateway8/1: [f23 eq 1] ==> [f24 set 1].
xrule xtt_gateway8/2: [f22 eq 1] ==> [f24 set 1].
xrule xtt_end/1: [f14 eq 1] ==> [end set 1] **> [[on_end,[end]]].
xrule xtt_end/2: [f24 eq 1] ==> [end set 1] **> [[on_end,[end]]].
xrule xtt_end/3: [f8 eq 1] ==> [end set 1] **> [[on_end,[end]]].
xrule xtt_end/4: [f3 eq 1] ==> [end set 1] **> [[on_end,[end]]].


xstat s1:[].




%%%%%%%%%%%%%%   Callbacks Stubs  %%%%%%%%%%%%%%%%

:-ensure_loaded(data).

%%%% Rules Callbacks %%%%

xactn on_start: [start] >>> writeln(on_start).

xactn 'on_Pin Request': ['Pin Request'] >>>(
			% alsv_value_get(current,cardId,CardId),

			writeln('Please provide you\'re card PIN'),
			read(Pin),
			alsv_new_val(enteredPin,Pin)
		).

xactn 'on_Operation Type Select': ['Operation Type Select'] >>>(
			writeln('Operation Type Select'),
			writeln('Please choose operation [status|withdrawal]'),
			read(Operation),
			alsv_new_val(operation,Operation)
		).

xactn 'on_Account Status Check ': ['Account Status Check '] >>>(
			writeln('on_Account Status Check '),
			alsv_values_get(current,cardID,CardID),
			card_account(CardID,_CardPin,_AccountId,AccountAmount),
			alsv_new_val(accountAmount,AccountAmount)
		).

xactn 'on_Wait Screen Display': ['Wait Screen Display'] >>> writeln('Wait Screen Display: please wait.').

xactn 'on_Acount Status Presentation': ['Acount Status Presentation'] >>> (
			alsv_values_get(current,accountAmount,AccountAmount),
			writef('Account amount is: %w', [AccountAmount])
		).

xactn 'on_Desired Amount Ask': ['Desired Amount Ask'] >>> (
			writeln('Please provide desired amount'),
			read(DesiredAmount),
			alsv_new_val(desiredAmount,DesiredAmount)
		).

xactn on_Payout: ['Payout'] >>> (
			writeln('Please take you\'re card and money.'),
			alsv_values_get(current,cardID,CardId),
			alsv_values_get(current,desiredAmount,DesiredAmount),
			card_account(CardId,_CardPin,AccountId,AccountAmount),
			AmountRest is AccountAmount - DesiredAmount,

			db_update([Amount=AmountRest], (account(Id,Amount), [Id=AccountId]))
		).

xactn 'on_Not Enough On Account': ['Not Enough On Account'] >>> (
			writeln('Sorry insufficient funds in your account')
		).
xactn on_end: [end] >>> (
		writeln('BYE BYE ...')
).


%%%% Attributes Callbacks %%%%

xcall get_cardID: [cardID] >>> (
			writeln('Please provide Card ID'),
			read(CardID),
			((\+card(CardID,_,_,_CorrectPin))
				-> writeln('No Card ID in database')
				; alsv_new_val(cardID,CardID))
		).
xcall get_correctPin: [correctPin] >>> (
			alsv_values_get(current,cardID,CardID),
			card(CardID,_,_,CorrectPin),
			alsv_new_val(correctPin,CorrectPin)
		).

% xcall get_operation: [operation] >>> (writeln(get_operation),read(Answer), alsv_new_val(operation,Answer)).
xcall get_accountAmount: [accountAmount] >>> (
			alsv_values_get(current,cardID,CardId),
			card_account(CardId,_CardPin,_AccountId,AccountAmount),
			alsv_new_val(accountAmount,AccountAmount)
		).
xcall get_desiredAmount: [desiredAmount] >>> (writeln(get_desiredAmount),read(Answer), alsv_new_val(desiredAmount,Answer)).
