%%%%%%%%%%%%%%	Attributes Types	%%%%%%%%%%%%%%%%

xtype [name:tpe_bpmn_entit,base:symbolic,length:4,scale:0,desc:'bpmn entity 1 - executed, null - not executed',domain:[null,1]].
xtype [name:integer,base:numeric,length:10,scale:0,desc:integer,domain:[-2147483648 to 2147483647]].


%%%%%%%%%%%%%%	Attributes	%%%%%%%%%%%%%%%%

xattr[name:start,abbrev:start1,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f1,abbrev:f11,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:'A1',abbrev:'A11',class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f2,abbrev:f21,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f3,abbrev:f31,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:'A2',abbrev:'A21',class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f4,abbrev:f41,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:'A3',abbrev:'A31',class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f5,abbrev:f51,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:'A4',abbrev:'A41',class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f6,abbrev:f61,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f7,abbrev:f71,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:'A5',abbrev:'A51',class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f8,abbrev:f81,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:'A6',abbrev:'A61',class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f9,abbrev:f91,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:end,abbrev:end1,class:simple,type:tpe_bpmn_entit,comm:inter].


%%%%%%%%%%%%%%	XTT Tables	%%%%%%%%%%%%%%%%

xschm xtt_start: [] ==> [f1,start].
xschm xtt_A1: [f1] ==> [f2,f3,'A1'].
xschm xtt_A2: [f2] ==> [f4,'A2'].
xschm xtt_A3: [f3] ==> [f5,'A3'].
xschm xtt_A4: [f4,f5] ==> [f6,f7,'A4'].
xschm xtt_A5: [f6] ==> [f8,'A5'].
xschm xtt_A6: [f7] ==> [f9,'A6'].
xschm xtt_end: [f9,f8] ==> [end].


xrule xtt_start/1: [] ==> [f1 set 1] **> [[on_start,[start]]].
xrule xtt_A1/1: [f1 eq 1] ==> ['A1' set 1,f2 set 1,f3 set 1] **> [[on_A1,['A1']]].
xrule xtt_A2/1: [f2 eq 1] ==> ['A2' set 1,f4 set 1] **> [[on_A2,['A2']]].
xrule xtt_A3/1: [f3 eq 1] ==> ['A3' set 1,f5 set 1] **> [[on_A3,['A3']]].
xrule xtt_A4/1: [f4 eq 1] ==> ['A4' set 1,f6 set 1,f7 set 1] **> [[on_A4,['A4']]].
xrule xtt_A4/2: [f5 eq 1] ==> ['A4' set 1,f6 set 1,f7 set 1] **> [[on_A4,['A4']]].
xrule xtt_A5/1: [f6 eq 1] ==> ['A5' set 1,f8 set 1] **> [[on_A5,['A5']]].
xrule xtt_A6/1: [f7 eq 1] ==> ['A6' set 1,f9 set 1] **> [[on_A6,['A6']]].
xrule xtt_end/1: [f9 eq 1] ==> [end set 1] **> [[on_end,[end]]].
xrule xtt_end/2: [f8 eq 1] ==> [end set 1] **> [[on_end,[end]]].


xstat s1:[].




%%%%%%%%%%%%%%	Callbacks Stubs	%%%%%%%%%%%%%%%%

%%%%	Rules Callbacks	%%%%

xactn on_start: [start] >>> writeln(on_start). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.
xactn on_A1: ['A1'] >>> writeln(on_A1). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.
xactn on_A2: ['A2'] >>> writeln(on_A2). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.
xactn on_A3: ['A3'] >>> writeln(on_A3). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.
xactn on_A4: ['A4'] >>> writeln(on_A4). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.
xactn on_A5: ['A5'] >>> writeln(on_A5). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.
xactn on_A6: ['A6'] >>> writeln(on_A6). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.
xactn on_end: [end] >>> writeln(on_end). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.


%%%%	Attributes Callbacks	%%%%

