%%%%%%%%%%%%%%	Attributes Types	%%%%%%%%%%%%%%%%

xtype [name:tpe_bpmn_entit,base:symbolic,length:4,scale:0,desc:'bpmn entity 1 - executed, null - not executed',domain:[null,1]].
xtype [name:integer,base:numeric,length:10,scale:0,desc:integer,domain:[-2147483648 to 2147483647]].


%%%%%%%%%%%%%%	Attributes	%%%%%%%%%%%%%%%%

xattr[name:e1,abbrev:e11,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f1,abbrev:f11,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f2,abbrev:f21,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f3,abbrev:f31,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:cond1,abbrev:cond11,class:simple,type:integer,comm:inter,callback:[get_cond1,[cond1]]].
xattr[name:a1,abbrev:a11,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:a2,abbrev:a21,class:simple,type:tpe_bpmn_entit,comm:inter].


%%%%%%%%%%%%%%	XTT Tables	%%%%%%%%%%%%%%%%

xschm xtt1: [] ==> [f1,e1].
xschm xtt2: [f1,cond1] ==> [f2,f3].
xschm xtt3: [f2,cond1] ==> [a1].
xschm xtt4: [f3] ==> [a2].


xrule xtt1/1: [] ==> [f1 set 1] **> [[on_e1,[e1]]].
xrule xtt2/1: [f1 eq 1,cond1 eq any] ==> [f2 set 1].
xrule xtt2/2: [f1 eq 1,f2 eq null] ==> [f3 set 1].
xrule xtt3/1: [f2 eq 1,cond1 eq any] ==> [a1 set 1] **> [[on_a1,[a1]]].
xrule xtt4/1: [f3 eq 1] ==> [a2 set 1] **> [[on_a2,[a2]]].


xstat s1:[].




%%%%%%%%%%%%%%	Callbacks Stubs	%%%%%%%%%%%%%%%%

%%%%	Rules Callbacks	%%%%

xactn on_e1: [e1] >>> writeln(on_e1). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.
xactn on_a1: [a1] >>> writeln(on_a1). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.
xactn on_a2: [a2] >>> writeln(on_a2). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.


%%%%	Attributes Callbacks	%%%%

xcall get_cond1: [cond1] >>> (writeln(get_cond1),read(Answer), alsv_new_val(cond1,Answer)).
