%%%%%%%%%%%%%%	Attributes Types	%%%%%%%%%%%%%%%%

xtype [name:tpe_bpmn_entit,base:symbolic,length:4,scale:0,desc:'bpmn entity 1 - executed, null - not executed',domain:[null,1]].
xtype [name:integer,base:numeric,length:10,scale:0,desc:integer,domain:[-2147483648 to 2147483647]].


%%%%%%%%%%%%%%	Attributes	%%%%%%%%%%%%%%%%

xattr[name:a7,abbrev:a71,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f10,abbrev:f101,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:a8,abbrev:a81,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f11,abbrev:f111,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f12,abbrev:f121,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:e4,abbrev:e41,class:simple,type:tpe_bpmn_entit,comm:inter].


%%%%%%%%%%%%%%	XTT Tables	%%%%%%%%%%%%%%%%

xschm xtt13: [] ==> [f10,a7].
xschm xtt14: [] ==> [f11,a8].
xschm xtt15: [f10,f11] ==> [f12].
xschm xtt16: [f12] ==> [e4].


xrule xtt13/1: [] ==> [f10 set 1] **> [[on_a7,[a7]]].
xrule xtt14/1: [] ==> [f11 set 1] **> [[on_a8,[a8]]].
xrule xtt15/1: [f10 eq 1,f11 eq 1] ==> [f12 set 1].
xrule xtt16/1: [f12 eq 1] ==> [e4 set 1] **> [[on_e4,[e4]]].


xstat s1:[].




%%%%%%%%%%%%%%	Callbacks Stubs	%%%%%%%%%%%%%%%%

%%%%	Rules Callbacks	%%%%

xactn on_a7: [a7] >>> writeln(on_a7). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.
xactn on_a8: [a8] >>> writeln(on_a8). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.
xactn on_e4: [e4] >>> writeln(on_e4). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.


%%%%	Attributes Callbacks	%%%%

