%%%%%%%%%%%%%%	Attributes Types	%%%%%%%%%%%%%%%%

xtype [name:tpe_bpmn_entit,base:symbolic,length:4,scale:0,desc:'bpmn entity 1 - executed, null - not executed',domain:[null,1]].
xtype [name:integer,base:numeric,length:10,scale:0,desc:integer,domain:[-2147483648 to 2147483647]].


%%%%%%%%%%%%%%	Attributes	%%%%%%%%%%%%%%%%

xattr[name:e3,abbrev:e31,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f7,abbrev:f71,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f8,abbrev:f81,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f9,abbrev:f91,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:a5,abbrev:a51,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:a6,abbrev:a61,class:simple,type:tpe_bpmn_entit,comm:inter].


%%%%%%%%%%%%%%	XTT Tables	%%%%%%%%%%%%%%%%

xschm xtt9: [] ==> [f7,e3].
xschm xtt10: [f7] ==> [f8,f9].
xschm xtt11: [f8] ==> [a5].
xschm xtt12: [f9] ==> [a6].


xrule xtt9/1: [] ==> [f7 set 1] **> [[on_e3,[e3]]].
xrule xtt10/1: [f7 eq 1] ==> [f8 set 1,f9 set 1].
xrule xtt11/1: [f8 eq 1] ==> [a5 set 1] **> [[on_a5,[a5]]].
xrule xtt12/1: [f9 eq 1] ==> [a6 set 1] **> [[on_a6,[a6]]].


xstat s1:[].




%%%%%%%%%%%%%%	Callbacks Stubs	%%%%%%%%%%%%%%%%

%%%%	Rules Callbacks	%%%%

xactn on_e3: [e3] >>> writeln(on_e3). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.
xactn on_a5: [a5] >>> writeln(on_a5). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.
xactn on_a6: [a6] >>> writeln(on_a6). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.


%%%%	Attributes Callbacks	%%%%

