CREATE TABLE "accounts"  ( 
	"id"    	integer NOT NULL,
	"amount"	integer NOT NULL,
	PRIMARY KEY("id")
);
CREATE TABLE "cards"  ( 
	"id"     	integer NOT NULL,
	"account"	integer NOT NULL,
	"client" 	integer NOT NULL,
	"pin"    	integer NOT NULL,
	PRIMARY KEY("id")
);
CREATE TABLE "clients"  ( 
	"id"        	integer NOT NULL,
	"first_name"	text NOT NULL,
	"last_name" 	text NOT NULL,
	PRIMARY KEY("id")
);
CREATE TABLE "clients_accounts"  ( 
	"client" 	integer NOT NULL,
	"account"	integer NOT NULL,
	PRIMARY KEY("client","account")
);
ALTER TABLE "clients_accounts"
	ADD CONSTRAINT "account_owners"
	FOREIGN KEY("account")
	REFERENCES "accounts"("id");
ALTER TABLE "cards"
	ADD CONSTRAINT "account_cards"
	FOREIGN KEY("account")
	REFERENCES "accounts"("id");
ALTER TABLE "clients_accounts"
	ADD CONSTRAINT "client_accounts"
	FOREIGN KEY("client")
	REFERENCES "clients"("id");
ALTER TABLE "cards"
	ADD CONSTRAINT "client_cards"
	FOREIGN KEY("client")
	REFERENCES "clients"("id");