%%%%%%%%%%%%%%	Attributes Types	%%%%%%%%%%%%%%%%

xtype [name:tpe_bpmn_entit,base:symbolic,length:4,scale:0,desc:'bpmn entity 1 - executed, null - not executed',domain:[null,1]].
xtype [name:integer,base:numeric,length:10,scale:0,desc:integer,domain:[-2147483648 to 2147483647]].


%%%%%%%%%%%%%%	Attributes	%%%%%%%%%%%%%%%%

xattr[name:a1,abbrev:a11,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f1,abbrev:f11,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f2,abbrev:f21,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:e1,abbrev:e11,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f3,abbrev:f31,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f4,abbrev:f41,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f5,abbrev:f51,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:v,abbrev:v1,class:simple,type:integer,comm:inter,callback:[get_v,[v]]].
xattr[name:a2,abbrev:a21,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f6,abbrev:f61,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:a3,abbrev:a31,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f7,abbrev:f71,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f8,abbrev:f81,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f9,abbrev:f91,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f10,abbrev:f101,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f11,abbrev:f111,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:a4,abbrev:a41,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f12,abbrev:f121,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:a5,abbrev:a51,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f13,abbrev:f131,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f14,abbrev:f141,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:a6,abbrev:a61,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:e2,abbrev:e21,class:simple,type:tpe_bpmn_entit,comm:inter].


%%%%%%%%%%%%%%	XTT Tables	%%%%%%%%%%%%%%%%

xschm xtt1: [f1] ==> [f2,a1].
xschm xtt2: [] ==> [f1,e1].
xschm xtt3: [f2,v] ==> [f3,f4,f5].
xschm xtt4: [f3,v] ==> [f6,a2].
xschm xtt5: [f5] ==> [f7,a3].
xschm xtt6: [f6,f7,f8] ==> [f9].
xschm xtt7: [f9] ==> [f10,f11].
xschm xtt8: [f10] ==> [f12,a4].
xschm xtt9: [f11] ==> [f13,a5].
xschm xtt10: [f12,f13] ==> [f14].
xschm xtt11: [f4,v] ==> [f8,a6].
xschm xtt12: [f14] ==> [e2].


xrule xtt1/1: [f1 eq 1] ==> [a1 set 1,f2 set 1] **> [[on_a1,[a1]]].
xrule xtt2/1: [] ==> [f1 set 1] **> [[on_e1,[e1]]].
xrule xtt3/1: [f2 eq 1,v in [1,2]] ==> [f3 set 1].
xrule xtt3/2: [f2 eq 1,f3 eq null,v in [3]] ==> [f4 set 1].
xrule xtt3/3: [f2 eq 1,f3 eq null,f4 eq null] ==> [f5 set 1].
xrule xtt4/1: [f3 eq 1,v in [1,2]] ==> [a2 set 1,f6 set 1] **> [[on_a2,[a2]]].
xrule xtt5/1: [f5 eq 1] ==> [a3 set 1,f7 set 1] **> [[on_a3,[a3]]].
xrule xtt6/1: [f6 eq 1] ==> [f9 set 1].
xrule xtt6/2: [f7 eq 1] ==> [f9 set 1].
xrule xtt6/3: [f8 eq 1] ==> [f9 set 1].
xrule xtt7/1: [f9 eq 1] ==> [f10 set 1,f11 set 1].
xrule xtt8/1: [f10 eq 1] ==> [a4 set 1,f12 set 1] **> [[on_a4,[a4]]].
xrule xtt9/1: [f11 eq 1] ==> [a5 set 1,f13 set 1] **> [[on_a5,[a5]]].
xrule xtt10/1: [f12 eq 1,f13 eq 1] ==> [f14 set 1].
xrule xtt11/1: [f4 eq 1,v in [3]] ==> [a6 set 1,f8 set 1] **> [[on_a6,[a6]]].
xrule xtt12/1: [f14 eq 1] ==> [e2 set 1] **> [[on_e2,[e2]]].


xstat s1:[].




%%%%%%%%%%%%%%	Callbacks Stubs	%%%%%%%%%%%%%%%%

%%%%	Rules Callbacks	%%%%

xactn on_a1: [a1] >>> writeln(on_a1). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.
xactn on_e1: [e1] >>> writeln(on_e1). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.
xactn on_a2: [a2] >>> writeln(on_a2). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.
xactn on_a3: [a3] >>> writeln(on_a3). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.
xactn on_a4: [a4] >>> writeln(on_a4). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.
xactn on_a5: [a5] >>> writeln(on_a5). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.
xactn on_a6: [a6] >>> writeln(on_a6). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.
xactn on_e2: [e2] >>> writeln(on_e2). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.


%%%%	Attributes Callbacks	%%%%

xcall get_v: [v] >>> (writeln(get_v),read(Answer), alsv_new_val(v,Answer)).
