%%%%%%%%%%%%%%	Attributes Types	%%%%%%%%%%%%%%%%

xtype [name:tpe_bpmn_entit,base:symbolic,length:4,scale:0,desc:'bpmn entity 1 - executed, null - not executed',domain:[null,1]].
xtype [name:integer,base:numeric,length:10,scale:0,desc:integer,domain:[-2147483648 to 2147483647]].


%%%%%%%%%%%%%%	Attributes	%%%%%%%%%%%%%%%%

xattr[name:a3,abbrev:a31,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f4,abbrev:f41,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f5,abbrev:f51,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:f6,abbrev:f61,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:a4,abbrev:a41,class:simple,type:tpe_bpmn_entit,comm:inter].
xattr[name:e2,abbrev:e21,class:simple,type:tpe_bpmn_entit,comm:inter].


%%%%%%%%%%%%%%	XTT Tables	%%%%%%%%%%%%%%%%

xschm xtt5: [] ==> [f4,a3].
xschm xtt6: [f4,f5] ==> [f6].
xschm xtt7: [] ==> [f5,a4].
xschm xtt8: [f6] ==> [e2].


xrule xtt5/1: [] ==> [f4 set 1] **> [[on_a3,[a3]]].
xrule xtt6/1: [f4 eq 1] ==> [f6 set 1].
xrule xtt6/2: [f5 eq 1] ==> [f6 set 1].
xrule xtt7/1: [] ==> [f5 set 1] **> [[on_a4,[a4]]].
xrule xtt8/1: [f6 eq 1] ==> [e2 set 1] **> [[on_e2,[e2]]].


xstat s1:[].




%%%%%%%%%%%%%%	Callbacks Stubs	%%%%%%%%%%%%%%%%

%%%%	Rules Callbacks	%%%%

xactn on_a3: [a3] >>> writeln(on_a3). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.
xactn on_a4: [a4] >>> writeln(on_a4). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.
xactn on_e2: [e2] >>> writeln(on_e2). %%% Put your code here; use alsv_new_val(AttName,Answer) to set attribute value.


%%%%	Attributes Callbacks	%%%%

